// File: ThreadTest.java
// Create and run some threads
// 2 classes here, a thread class and a main class to
//      instantiate some instances of the thread class
//
// Note that there are no throws clauses because every possible exception is caught

import java.io.*;

class TheThread extends Thread
{	int mSeconds;  // Sleep duration

  // Constructor: Get sleep duration and print it
  public TheThread(String S)
  {	super(S);
  	mSeconds= (int)(500*Math.random()); //Number between 0 and 500
  	// Announce thread number and # milliseconds it will sleep
  	System.out.println("Name: "+ getName()+" will sleep "
        	                    +mSeconds+"/1000 of a second");
  }

  // run() executes when the thread is started
  public void run()
  {	try {
   		sleep(mSeconds);
  	}
  	catch (Exception e) 
	{}
  	System.out.println("Thread "+getName()+ " done");
  }

} // class

public class ThreadTest {

  static int ReadInt() throws java.io.IOException
  {	BufferedReader DataIn = 
		new BufferedReader(new InputStreamReader(System.in));
  	String Input=DataIn.readLine();
  	return (Integer.valueOf(Input).intValue());
  }

  public static void main(String[] args)
  {	int numberOfThreads=0;
  	// Get number of threads to test
  	try {
   		System.out.print("How many threads?  >");
   		numberOfThreads=ReadInt();
  	}
  	catch (Exception e) 
	{}
  	// Declare array of threads
  	TheThread[] Them=new TheThread[numberOfThreads];
  	// Instantiate each thread
  	for (int i=0;i<numberOfThreads;i++)
   	Them[i]=new TheThread(String.valueOf(i));
  	// Start the threads
  	for (int i=0;i<numberOfThreads;i++)
   		Them[i].start();
 	try {	
		Thread.sleep(2000);
		System.out.println("Press Enter to Finish");
  		System.in.read();
 	}
 	catch (Exception e) 
	{}
  }

} // main class

